/*
 *+--------------------------------------------------------------------------------------+
 *| Licensed Materials - Use restricted, please refer to the "Samples Gallery" terms and |
 *| conditions in the IBM International Program License Agreement.
 *| (C) Copyright IBM Corporation 2003, 2004. All Rights Reserved.						 |	
 *+--------------------------------------------------------------------------------------+
 */
package itso.ad.presentation.gui;



import itso.ad.business.ejb.facade.PiggyBankController;
import itso.ad.business.ejb.facade.PiggyBankControllerHome;
import itso.ad.business.framework.exception.ServiceException;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JTextField;

public class PiggyBankCustomerAccountCreation extends JFrame {
	
	// EJB session bean reference
	private static final String PIGGY_BANK_CONTROLLER_EJB_REF  = "ejb/PiggyBankController";
	private static final String PIGGY_BANK_CONTROLLER_JNDINAME = "ejb/itso/ad/business/ejb/facade/PiggyBankControllerHome";

	private javax.swing.JPanel jContentPane = null;

	private javax.swing.JLabel jLabel = null;
	private javax.swing.JLabel jLabel1 = null;
	private javax.swing.JLabel jLabel2 = null;
	private javax.swing.JTextField creditAccount = null;
	private javax.swing.JTextField checkReference = null;
	private javax.swing.JTextField amount = null;
	private javax.swing.JButton cashCheckButton = null;
	private javax.swing.JLabel message = null;
	
	private javax.swing.JLabel customerNameLabel=null;
	private javax.swing.JLabel customerIDLabel=null;
	private javax.swing.JLabel validateCustomerLabel=null;
	private javax.swing.JLabel accountsLabel=null;
	private javax.swing.JLabel accountIDLabel=null;
	
	private JTextField customerID;
	private JTextField accountID;
	private JButton newAccountButton;
	private JTextField customerName;
	private JList accountsList;
	
	java.util.List existingAccounts=new java.util.ArrayList();
	private JButton newCustomerButton;

	
	public static void main(String[] args) {
		System.out.println("PiggyBank Teller Application Start");
		PiggyBankCustomerAccountCreation app = new PiggyBankCustomerAccountCreation();
		app.setVisible(true);
	}
	/**
	 * This is the default constructor
	 */
	public PiggyBankCustomerAccountCreation() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(300, 200);
		this.setContentPane(getJContentPane());
		this.setTitle("PiggyBank Teller Application for creating new customers and accounts");
		this.addWindowListener(new java.awt.event.WindowAdapter() { 
			public void windowClosing(java.awt.event.WindowEvent e) {    
				System.out.println("PiggyBank Teller Application End");    
				System.exit(0);
			}
		});
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			
			java.awt.GridBagConstraints consGridBagConstraints18 = new java.awt.GridBagConstraints();
			
			
			java.awt.GridBagConstraints consGridBagCustomerNameLabel = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagCustomerName = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagCustomerIDLabel = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagCustomerID = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagNewCustomerLabel = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagNewCustomerButton = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagAccountIDLabel = new java.awt.GridBagConstraints();
			java.awt.GridBagConstraints consGridBagAccountID = new java.awt.GridBagConstraints();
			
		
			consGridBagConstraints18.gridy = 12;
			consGridBagConstraints18.gridx = 0;
			consGridBagConstraints18.gridwidth = 2;
			consGridBagConstraints18.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagConstraints18.insets = new java.awt.Insets(5,10,5,10);
			
			consGridBagCustomerIDLabel.gridy = 2;
			consGridBagCustomerIDLabel.gridx = 0;
			consGridBagCustomerIDLabel.insets = new java.awt.Insets(5,10,5,10);
			consGridBagCustomerIDLabel.anchor = java.awt.GridBagConstraints.WEST;
			
			consGridBagCustomerID.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagCustomerID.weightx = 1.0;
			consGridBagCustomerID.gridy = 2;
			consGridBagCustomerID.gridx = 1;
			consGridBagCustomerID.insets = new java.awt.Insets(5,10,5,10);
				
					
			consGridBagCustomerNameLabel.gridy =3;
			consGridBagCustomerNameLabel.gridx = 0;
			consGridBagCustomerNameLabel.insets = new java.awt.Insets(5,10,5,10);
			consGridBagCustomerNameLabel.anchor = java.awt.GridBagConstraints.WEST;
			
			
			
			consGridBagCustomerName.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagCustomerName.weightx = 1.0;
			consGridBagCustomerName.gridy = 3;
			consGridBagCustomerName.gridx = 1;
			consGridBagCustomerName.insets = new java.awt.Insets(5,10,5,10);
			
			
			consGridBagAccountIDLabel.gridy = 4;
			consGridBagAccountIDLabel.gridx = 0;
			consGridBagAccountIDLabel.insets = new java.awt.Insets(5,10,5,10);
			consGridBagAccountIDLabel.anchor = java.awt.GridBagConstraints.WEST;
			
			consGridBagAccountID.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagAccountID.weightx = 1.0;
			consGridBagAccountID.gridy = 4;
			consGridBagAccountID.gridx = 1;
			consGridBagAccountID.insets = new java.awt.Insets(5,10,5,10);
			consGridBagAccountID.anchor = java.awt.GridBagConstraints.WEST;
			
			consGridBagNewCustomerButton.fill = java.awt.GridBagConstraints.HORIZONTAL;
			consGridBagNewCustomerButton.weightx=1.0;
			consGridBagNewCustomerButton.gridy = 8;
			consGridBagNewCustomerButton.gridx = 1;
			consGridBagNewCustomerButton.insets = new java.awt.Insets(5,10,5,10);
			consGridBagNewCustomerButton.anchor = java.awt.GridBagConstraints.WEST;
			
					
			jContentPane.setLayout(new java.awt.GridBagLayout());
			jContentPane.add(getCustomerIDLabel(), consGridBagCustomerIDLabel);
			jContentPane.add(getCustomerID(), consGridBagCustomerID);
			jContentPane.add(getCustomerNameLabel(), consGridBagCustomerNameLabel);
			jContentPane.add(getCustomerName(), consGridBagCustomerName);
			jContentPane.add(getAccountIDLabel(), consGridBagAccountIDLabel);
			jContentPane.add(getAccountID(), consGridBagAccountID);
						
			jContentPane.add(getNewCustomerButton(), consGridBagNewCustomerButton);
			jContentPane.add(getMessage(), consGridBagConstraints18);
			
		}
		return jContentPane;
	}

	
	
	/**
	 * This method initializes apply button
	 * 
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getNewCustomerButton() {
		if(newCustomerButton == null) {
			newCustomerButton = new javax.swing.JButton();
			newCustomerButton.setText("Apply");
			newCustomerButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					newCustomer();
				}
			});
		}
		return newCustomerButton;
	}
	
	/**
	 * This method initializes customer Name label
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getCustomerNameLabel() {
		if(customerNameLabel == null) {
			customerNameLabel = new javax.swing.JLabel();
			customerNameLabel.setText("Customer Name");
		}
		return customerNameLabel;
	}
	/**
	 * This method initializes customerID label
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getCustomerIDLabel() {
		if(customerIDLabel == null) {
			customerIDLabel = new javax.swing.JLabel();
			customerIDLabel.setText("Customer ID:");
		}
		return customerIDLabel;
	}
	
	/**
	 * This method initializes accountID label
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getAccountIDLabel() {
		if(accountIDLabel == null) {
			accountIDLabel = new javax.swing.JLabel();
			accountIDLabel.setText("account no:");
		}
		return accountIDLabel;
	}
	
	/**
	 * This method return the input field for customerID
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getCustomerID() {
		if(customerID == null) {
			customerID = new javax.swing.JTextField();
		}
		return customerID;
	}
	/**
	 * This method return the input field for customer name
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getCustomerName() {
		if(customerName == null) {
			customerName = new javax.swing.JTextField();
		}
		return customerName;
	}
	/**
	 * This method return the input field for accountID
	 * 
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getAccountID() {
		if(accountID == null) {
			accountID = new javax.swing.JTextField();
		}
		return accountID;
	}
	
	private void newCustomer()
	{
		createNewCustomer();	
	}
	/**
	 * This method initializes message
	 * 
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getMessage() {
		if(message == null) {
			message = new javax.swing.JLabel();
			message.setText("Welcome to PiggyBank Teller Application");
		}
		return message;
	}
	
	/**
	 * This method create new customer and account
	 * 
	 */
	private void createNewCustomer()
	{
		System.out.println("Creating customer and account...");
		
		String customerName  = getCustomerName().getText();
		String customerId= getCustomerID().getText();
		String accountNumber    = getAccountID().getText();	
		getMessage().setText("Msg: Creating customer("+customerId+") and account("+ accountNumber + ")");

		try {
			paint(getGraphics());
			System.out.println("Retrieving PiggyBankController");
			InitialContext initialContext = new InitialContext();
			
			Object nsObject = initialContext.lookup(PIGGY_BANK_CONTROLLER_JNDINAME);
			PiggyBankControllerHome piggyBankControllerHome = (PiggyBankControllerHome) PortableRemoteObject.narrow(nsObject, PiggyBankControllerHome.class);
			PiggyBankController     piggyBankController = piggyBankControllerHome.create();
			System.out.println("creating customer and account");
			piggyBankController.createNewCustomer(customerId, customerName, accountNumber);
			System.out.println("created successfully");
			getMessage().setText("Msg: created successfully");
		} catch (ServiceException e) {
			System.out.println("ServiceException: "+e.getMessage());
			String code = e.getErrorCode(); if (code == null) code = "error.unknown";
			Throwable t = e.getRootCause(); if (t == null) t = e;
			System.out.println("ServiceException: "+code+" "+t);
			if (code.equals("error.check.invalid"))
				getMessage().setText("Msg: Invalid check - says CityBank");
			else if (code.equals("error.credit.account"))
				getMessage().setText("Msg: Invalid account number");
			else
				getMessage().setText("Error: "+t);
		} catch (Exception e) {
			System.out.println("Exception:" + e.getMessage());
			e.printStackTrace();
			getMessage().setText(e.getClass().getName()+": "+e.getMessage());
		}
		
	}

}

