/*
 *+--------------------------------------------------------------------------------------+
 *| Licensed Materials - Use restricted, please refer to the "Samples Gallery" terms and |
 *| conditions in the IBM International Program License Agreement.						 |	
 *|  Copyright IBM Corporation 2003, 2004. All Rights Reserved.						 |
 *+--------------------------------------------------------------------------------------+
 */

package itso.ad.presentation.servlet;

import itso.ad.business.framework.interfaces.to.ICustomerTO;

import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class MainMenuServlet extends BaseServlet {
	/* (non-Java-doc)
	 * @see itso.ad.presentation.servlet.BaseServlet#BaseServlet()
	 */
	public MainMenuServlet() {
		super();
	}

	/* (non-Java-doc)
	 * @see itso.ad.presentation.servlet.BaseServlet#performTask(HttpServletRequest req, HttpServletResponse resp)
	 */
	protected void performTask(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			// check if security is enabled and a user identified
			if (req.getRemoteUser() == null && req.getParameter("j_username") == null) 
				forwardTo("/html/UnsecureLoginForm.html", req, resp);
			ICustomerTO customer = getCustomer(req);
			// log.debug("Retrieved customer "+customer.getName());
			req.setAttribute("customer", customer);
			forwardTo("/secure/MainMenu.jsp", req, resp);		
		}
		catch (Exception e) {
			handleException(e, req, resp);
		}
	}

}