/*
 *+--------------------------------------------------------------------------------------+
 *| Licensed Materials - Use restricted, please refer to the "Samples Gallery" terms and |
 *| conditions in the IBM International Program License Agreement.						 |	
 *|  Copyright IBM Corporation 2003, 2004. All Rights Reserved.						 |
 *+--------------------------------------------------------------------------------------+
 */

package itso.ad.presentation.servlet;

import itso.ad.business.framework.interfaces.to.ICustomerTO;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class TransferServlet extends BaseServlet implements Servlet {
	/* (non-Java-doc)
	 * @see itso.ad.presentation.servlet.BaseServlet#BaseServlet()
	 */
	public TransferServlet() {
		super();
	}

	/* (non-Java-doc)
	 * @see itso.ad.presentation.servlet.BaseServlet#performTask(HttpServletRequest req, HttpServletResponse resp)
	 */
	protected void performTask(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			String step = request.getParameter("step");
			if ("1".equals(step)) {
				ICustomerTO customer = getCustomer(request);
				java.util.List accounts = getPiggyBankService().getAccountsByCustomer(customer);
				request.setAttribute("accounts", accounts);
				forwardTo("/secure/TransferAccounts.jsp", request, response);
			} else if ("2".equals(step)) {
				forwardTo("/secure/TransferForm.jsp", request, response);
			} else if ("3".equals(step)) {
				ICustomerTO customer = getCustomer(request);
				getPiggyBankService().transfer(customer, request.getParameter("debitAccountNumber"), request.getParameter("creditAccountNumber"), new Integer(Integer.parseInt(request.getParameter("amount"))));
				forwardTo("/secure/TransferResult.jsp", request, response);
			}
		} catch (Exception e) {
			handleException(e, request, response);
		}
	}

}